""" NTL Browser views

$Id: browser.py,v 1.1.1.1 2006/04/26 12:25:18 tseaver Exp $
"""
from Products.GenericSetup.interfaces import IFilesystemExporter
from Products.GenericSetup.interfaces import IFilesystemImporter
from Products.GenericSetup.context import TarballExportContext
from Products.GenericSetup.context import TarballImportContext

class FolderTgzExport:
    """ View class for exporting folder contents as a gzipped tarball.
    """

    def export_as_tarball(self):
        export_context = TarballExportContext(tool=None, encoding='UTF8')
        adapter = IFilesystemExporter(self.context)
        adapter.export(export_context, '', True)
        self.request.RESPONSE.setHeader('Content-Type', 'application/gzip')
        return export_context.getArchive()

    def import_from_tarball(self, archive_bits):

        if getattr(archive_bits, 'read', None) is not None:
            archive_bits = archive_bits.read()

        import_context = TarballImportContext(tool=None,
                                              archive_bits=archive_bits,
                                              encoding='UTF8',
                                              should_purge=True,
                                             )

        adapter = IFilesystemImporter(self.context)
        adapter.import_(import_context, '', True)

    def upload(self):
        form = self.request.form
        file = form.get('file')
        if file is not None:
            self.import_from_tarball(file)
            return 'Uploaded'
        else:
            return 'No file'
